--  C:\PROJETO_ISH\MULTILATERATION\DIV_FACTOR_CONTROL.vhd
--  VHDL code created by Xilinx's StateCAD 9.1i
--  Thu Jun 28 22:25:28 2007

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  binary encoded state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are manually optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY DIV_FACTOR_CONTROL IS
	PORT (CLK,MULT1_RDY,SCLR,START,SUB1_RDY: IN std_logic;
		LOAD_PART_REG,LOAD_REGS,MULT1_ND,MUX_SEL,RDY,SUB_ND : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF DIV_FACTOR_CONTROL IS
	SIGNAL sreg : std_logic_vector (3 DOWNTO 0);
	SIGNAL next_sreg : std_logic_vector (3 DOWNTO 0);
	CONSTANT IDLE_ST : std_logic_vector (3 DOWNTO 0) :="0000";
	CONSTANT LD_PART_MULT2_ST : std_logic_vector (3 DOWNTO 0) :="0001";
	CONSTANT LOAD_ST : std_logic_vector (3 DOWNTO 0) :="0010";
	CONSTANT MULT1_INIT_ST : std_logic_vector (3 DOWNTO 0) :="0011";
	CONSTANT MULT1_WAIT_ST : std_logic_vector (3 DOWNTO 0) :="0100";
	CONSTANT MULT2_INIT_ST : std_logic_vector (3 DOWNTO 0) :="0101";
	CONSTANT SUB_INIT_ST : std_logic_vector (3 DOWNTO 0) :="0110";
	CONSTANT SUB_RDY_ST : std_logic_vector (3 DOWNTO 0) :="0111";
	CONSTANT SUB_WAIT_ST : std_logic_vector (3 DOWNTO 0) :="1000";

	SIGNAL next_LOAD_PART_REG,next_LOAD_REGS,next_MULT1_ND,next_MUX_SEL,next_RDY
		,next_SUB_ND : std_logic;
BEGIN
	PROCESS (CLK, next_sreg, next_LOAD_PART_REG, next_LOAD_REGS, next_MULT1_ND, 
		next_MUX_SEL, next_RDY, next_SUB_ND)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			sreg <= next_sreg;
			LOAD_PART_REG <= next_LOAD_PART_REG;
			LOAD_REGS <= next_LOAD_REGS;
			MULT1_ND <= next_MULT1_ND;
			MUX_SEL <= next_MUX_SEL;
			RDY <= next_RDY;
			SUB_ND <= next_SUB_ND;
		END IF;
	END PROCESS;

	PROCESS (sreg,MULT1_RDY,SCLR,START,SUB1_RDY)
	BEGIN
		next_LOAD_PART_REG <= '0'; next_LOAD_REGS <= '0'; next_MULT1_ND <= '0'; 
			next_MUX_SEL <= '0'; next_RDY <= '0'; next_SUB_ND <= '0'; 

		next_sreg<=IDLE_ST;

		IF ( SCLR='1' ) THEN
			next_sreg<=IDLE_ST;
			next_LOAD_PART_REG<='0';
			next_LOAD_REGS<='0';
			next_MULT1_ND<='0';
			next_MUX_SEL<='0';
			next_RDY<='0';
			next_SUB_ND<='0';
		ELSE
			CASE sreg IS
				WHEN IDLE_ST =>
					IF ( START='1' ) THEN
						next_sreg<=LOAD_ST;
						next_LOAD_PART_REG<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_RDY<='0';
						next_SUB_ND<='0';
						next_LOAD_REGS<='1';
					 ELSE
						next_sreg<=IDLE_ST;
						next_LOAD_PART_REG<='0';
						next_LOAD_REGS<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_RDY<='0';
						next_SUB_ND<='0';
					END IF;
				WHEN LD_PART_MULT2_ST =>
					IF ( MULT1_RDY='1' ) THEN
						next_sreg<=SUB_INIT_ST;
						next_LOAD_PART_REG<='0';
						next_LOAD_REGS<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_RDY<='0';
						next_SUB_ND<='1';
					 ELSE
						next_sreg<=LD_PART_MULT2_ST;
						next_LOAD_REGS<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_RDY<='0';
						next_SUB_ND<='0';
						next_LOAD_PART_REG<='1';
					END IF;
				WHEN LOAD_ST =>
					next_sreg<=MULT1_INIT_ST;
					next_LOAD_PART_REG<='0';
					next_LOAD_REGS<='0';
					next_MUX_SEL<='0';
					next_RDY<='0';
					next_SUB_ND<='0';
					next_MULT1_ND<='1';
				WHEN MULT1_INIT_ST =>
					next_sreg<=MULT2_INIT_ST;
					next_LOAD_PART_REG<='0';
					next_LOAD_REGS<='0';
					next_RDY<='0';
					next_SUB_ND<='0';
					next_MUX_SEL<='1';
					next_MULT1_ND<='1';
				WHEN MULT1_WAIT_ST =>
					IF ( MULT1_RDY='1' ) THEN
						next_sreg<=LD_PART_MULT2_ST;
						next_LOAD_REGS<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_RDY<='0';
						next_SUB_ND<='0';
						next_LOAD_PART_REG<='1';
					 ELSE
						next_sreg<=MULT1_WAIT_ST;
						next_LOAD_PART_REG<='0';
						next_LOAD_REGS<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_RDY<='0';
						next_SUB_ND<='0';
					END IF;
				WHEN MULT2_INIT_ST =>
					next_sreg<=MULT1_WAIT_ST;
					next_LOAD_PART_REG<='0';
					next_LOAD_REGS<='0';
					next_MULT1_ND<='0';
					next_MUX_SEL<='0';
					next_RDY<='0';
					next_SUB_ND<='0';
				WHEN SUB_INIT_ST =>
					next_sreg<=SUB_WAIT_ST;
					next_LOAD_PART_REG<='0';
					next_LOAD_REGS<='0';
					next_MULT1_ND<='0';
					next_MUX_SEL<='0';
					next_RDY<='0';
					next_SUB_ND<='0';
				WHEN SUB_RDY_ST =>
					IF ( START='1' ) THEN
						next_sreg<=LOAD_ST;
						next_LOAD_PART_REG<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_RDY<='0';
						next_SUB_ND<='0';
						next_LOAD_REGS<='1';
					 ELSE
						next_sreg<=SUB_RDY_ST;
						next_LOAD_PART_REG<='0';
						next_LOAD_REGS<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_SUB_ND<='0';
						next_RDY<='1';
					END IF;
				WHEN SUB_WAIT_ST =>
					IF ( SUB1_RDY='1' ) THEN
						next_sreg<=SUB_RDY_ST;
						next_LOAD_PART_REG<='0';
						next_LOAD_REGS<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_SUB_ND<='0';
						next_RDY<='1';
					 ELSE
						next_sreg<=SUB_WAIT_ST;
						next_LOAD_PART_REG<='0';
						next_LOAD_REGS<='0';
						next_MULT1_ND<='0';
						next_MUX_SEL<='0';
						next_RDY<='0';
						next_SUB_ND<='0';
					END IF;
				WHEN OTHERS =>
			END CASE;
		END IF;
	END PROCESS;
END BEHAVIOR;
