--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.1.03i
--  \   \         Application : ISE
--  /   /         Filename : mult_lat_test2.vhw
-- /___/   /\     Timestamp : Sun Jul 01 21:45:20 2007
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: mult_lat_test2
--Device: Xilinx
--

library UNISIM;
use UNISIM.Vcomponents.ALL;
library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE STD.TEXTIO.ALL;

ENTITY mult_lat_test2 IS
END mult_lat_test2;

ARCHITECTURE testbench_arch OF mult_lat_test2 IS
    FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";

    COMPONENT multilateration
        PORT (
            A11 : In std_logic_vector (31 DownTo 0);
            A12 : In std_logic_vector (31 DownTo 0);
            A21 : In std_logic_vector (31 DownTo 0);
            A22 : In std_logic_vector (31 DownTo 0);
            A31 : In std_logic_vector (31 DownTo 0);
            A32 : In std_logic_vector (31 DownTo 0);
            B11 : In std_logic_vector (31 DownTo 0);
            B21 : In std_logic_vector (31 DownTo 0);
            B31 : In std_logic_vector (31 DownTo 0);
            CLK : In std_logic;
            RESET : In std_logic;
            start : In std_logic;
            rdy : Out std_logic;
            x : Out std_logic_vector (31 DownTo 0);
            y : Out std_logic_vector (31 DownTo 0)
        );
    END COMPONENT;

    SIGNAL A11 : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL A12 : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL A21 : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL A22 : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL A31 : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL A32 : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL B11 : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL B21 : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL B31 : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL CLK : std_logic := '0';
    SIGNAL RESET : std_logic := '0';
    SIGNAL start : std_logic := '0';
    SIGNAL rdy : std_logic := '0';
    SIGNAL x : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";
    SIGNAL y : std_logic_vector (31 DownTo 0) := "00000000000000000000000000000000";

    constant PERIOD : time := 200 ns;
    constant DUTY_CYCLE : real := 0.5;
    constant OFFSET : time := 100 ns;

    BEGIN
        UUT : multilateration
        PORT MAP (
            A11 => A11,
            A12 => A12,
            A21 => A21,
            A22 => A22,
            A31 => A31,
            A32 => A32,
            B11 => B11,
            B21 => B21,
            B31 => B31,
            CLK => CLK,
            RESET => RESET,
            start => start,
            rdy => rdy,
            x => x,
            y => y
        );

        PROCESS    -- clock process for CLK
        BEGIN
            WAIT for OFFSET;
            CLOCK_LOOP : LOOP
                CLK <= '0';
                WAIT FOR (PERIOD - (PERIOD * DUTY_CYCLE));
                CLK <= '1';
                WAIT FOR (PERIOD * DUTY_CYCLE);
            END LOOP CLOCK_LOOP;
        END PROCESS;

        PROCESS
            BEGIN
                -- -------------  Current Time:  100ns
                WAIT FOR 100 ns;
                A11 <= "01000001001000000000000000000000";
                A12 <= "01000010010101000000000000000000";
                A21 <= "01000100100110100100000000000000";
                A22 <= "00111111100000000000000000000000";
                A31 <= "01000001010000000000000000000000";
                A32 <= "11000100000101100000000000000000";
                B11 <= "01000011011010100000000000000000";
                B21 <= "01000001001100000000000000000000";
                B31 <= "01000100101111001110000000000000";
                -- -------------------------------------
                -- -------------  Current Time:  185ns
                WAIT FOR 85 ns;
                RESET <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  385ns
                WAIT FOR 200 ns;
                RESET <= '0';
                start <= '1';
                -- -------------------------------------
                -- -------------  Current Time:  585ns
                WAIT FOR 200 ns;
                start <= '0';
                -- -------------------------------------
                WAIT FOR 49615 ns;

            END PROCESS;

    END testbench_arch;

